package foele.io;

/**
 * This type was created in VisualAge.
 */
public class TeeWriter extends java.io.Writer {
	protected java.io.Writer wr1;
	protected java.io.Writer wr2;
/**
 * This method was created in VisualAge.
 * @param wr1 java.io.Writer
 * @param wr2 java.io.Writer
 */
public TeeWriter(java.io.Writer wr1,java.io.Writer wr2) {
	super();
	this.wr1=wr1;
	this.wr2=wr2;
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 18.45.07)
 * @param wr1 java.io.Writer
 * @param wr2 java.io.Writer
 * @param lock java.lang.Object
 */
public TeeWriter(java.io.Writer wr1, java.io.Writer wr2, Object lock) {
	super(lock);
	this.wr1=wr1;
	this.wr2=wr2;
}
/**
 * close method comment.
 */
public void close() throws java.io.IOException {
	synchronized(lock){
		wr1.close();
		wr2.close();
	}
}
/**
 * flush method comment.
 */
public void flush() throws java.io.IOException {
	synchronized(lock){
		wr1.flush();
		wr2.flush();
	}
}
/**
 * write method comment.
 */
public void write(char[] cbuf, int off, int len) throws java.io.IOException {
	synchronized(lock){
		wr1.write(cbuf,off,len);
		wr2.write(cbuf,off,len);
	}
}
}
