package foele.io;

/**
 * Attention it never automatically flushes
 * Creation date: (13/08/99 18.41.59)
 * @author: 
 */
public class TextAreaWriter extends java.io.Writer {
	private javax.swing.JTextArea JTA;
	private java.awt.TextArea TA;
	private java.lang.StringBuffer InternalBuffer = new StringBuffer();
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 18.47.07)
 * @param TA java.awt.TextArea
 */
public TextAreaWriter(java.awt.TextArea TA) {
	super();
	this.TA=TA;
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 18.47.48)
 * @param TA java.awt.TextArea
 * @param lock java.lang.Object
 */
public TextAreaWriter(java.awt.TextArea TA, Object lock) {
	super(lock);
	this.TA=TA;
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 18.48.07)
 * @param JTA javax.swing.JTextArea
 */
public TextAreaWriter(javax.swing.JTextArea JTA) {
	super();
	this.JTA=JTA;
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 18.48.52)
 * @param JTA javax.swing.JTextArea
 * @param lock java.lang.Object
 */
public TextAreaWriter(javax.swing.JTextArea JTA, Object lock) {
	super(lock);
	this.JTA=JTA;
}
/**
 * close method comment.
 */
public void close() throws java.io.IOException {
	synchronized(lock){
		flush();
		JTA=null;
		TA=null;
	}
}
/**
 * flush method comment.
 */
public void flush() throws java.io.IOException {
	synchronized(lock){
		if (JTA!=null){
			JTA.setText(JTA.getText()+InternalBuffer);
		}
		if (TA!=null){
			TA.setText(TA.getText()+InternalBuffer);
		}
		InternalBuffer=new StringBuffer();
	}
}
/**
 * write method comment.
 */
public void write(char[] cbuf, int off, int len) throws java.io.IOException {
	synchronized(lock){
		InternalBuffer.append(cbuf,off,len);
	}
}
}
