package foele.jini.lease;

/**
 * This type was created in VisualAge.
 */
class Ticker implements Runnable{
	java.util.SortedMap TS=java.util.Collections.synchronizedSortedMap(new java.util.TreeMap());
	Thread clock;
	private java.util.Vector TickerListeners = new java.util.Vector();
/**
 * Ticker constructor comment.
 */
public Ticker() {
	super();
	clock=new Thread(this);
	clock.setDaemon(true);
	clock.start();
}
/**
 * This method was created in VisualAge.
 * @param TL foele.jini.lease.TickerListener
 */
public void addTickerListener(TickerListener TL) {
	TickerListeners.addElement(TL);
}
/**
 * This method was created in VisualAge.
 * @param TL foele.jini.lease.TickerListener
 */
public void removeTickerListener(TickerListener TL) {
	TickerListeners.removeElement(TL);
}
/**
 * This method was created in VisualAge.
 */
synchronized void rescheduleTick() {
	clock.interrupt();
}
/**
 * This method was created in VisualAge.
 */
public void run() {
	while (true) {
		
		Object o=null;
		try {
			o=TS.firstKey();
		}
		catch (java.util.NoSuchElementException e){}
		long nextScheduledTick=-1L;
		if (o!=null)
			nextScheduledTick=((Long)o).longValue();
		else nextScheduledTick=Long.MAX_VALUE;
		long sleepTime=nextScheduledTick-System.currentTimeMillis();
		//System.out.println("sleepTime : " +sleepTime);
		try {
			Thread.currentThread().sleep(sleepTime>0?sleepTime:0);
		}
		catch (InterruptedException e){
			//System.out.println("interrupted");
			continue;
		}
		net.jini.core.lease.Lease lease=null;
		try {
			lease=(net.jini.core.lease.Lease)TS.remove(TS.firstKey());
		}
		catch (java.util.NoSuchElementException e){}
		if (lease==null)
			continue;
		
		//System.out.println("lease to remove : "+ lease);
		final TickerEvent TE=new TickerEvent(this,lease);
		//System.out.println("TickerEvent :"+TE);
		new Thread (new Runnable (){
				public void run(){
					for(int i=0;i<TickerListeners.size();i++)
						((TickerListener)TickerListeners.elementAt(i)).tick(TE);
				}
			}).start();
		}		
}
/**
 * This method was created in VisualAge.
 * @param interval long
 */
public void scheduleTick(net.jini.core.lease.Lease lease,long leaseFor) {
	//System.out.println("Schedule leaseFor:"+leaseFor+ " current time:"+ System.currentTimeMillis());
	long expTime=leaseFor+System.currentTimeMillis();
	//System.out.println("Schedule expTime:"+expTime+ " current time:"+ System.currentTimeMillis());
	TS.put(new Long(expTime),lease);
	if (TS.firstKey().equals(new Long(expTime)))
		rescheduleTick();
}
}
