package foele.jini.lease.example;

/**
 * This type was created in VisualAge.
 */
public class Client {
/**
 * Client constructor comment.
 */
public Client() {
	super();
}
/**
 * Starts the application.
   primo argomento nome del string holder secondo porta terzo host
  
 * @param args an array of command-line arguments
 */
public static void main(java.lang.String[] args) throws java.io.IOException {
	System.setOut(new java.io.PrintStream(new foele.io.TeeOutputStream(System.out,new java.io.PrintStream(new java.io.FileOutputStream(Client.class+".log")))));
	String SHIname=args[0];
	int SHIport=Integer.parseInt(args[1]);
	String SHIhost=args[2];
	try {
		System.setSecurityManager(new java.rmi.RMISecurityManager());
		java.rmi.registry.Registry SHIreg=java.rmi.registry.LocateRegistry.getRegistry(SHIhost,SHIport);
		System.out.println(SHIreg);
		Object SHI=SHIreg.lookup(SHIname);
		System.out.println(SHI);
		net.jini.core.lease.Lease lease=((foele.jini.lease.LeasedResource)SHI).createNewLease(10000L);
		System.out.println(lease);
		com.sun.jini.lease.LeaseRenewalManager LRM=new com.sun.jini.lease.LeaseRenewalManager(lease,50000L,new com.sun.jini.lease.LeaseListener () {
			public void notify(com.sun.jini.lease.LeaseRenewalEvent LRE){
				System.out.println("notify"+LRE);
				}
		});
		
		System.out.println(LRM);
		((LeasedStringHolder)SHI).setString("Hello World",lease);
		//Thread.currentThread().sleep(30000L);
		System.out.println(((LeasedStringHolder)SHI).getString(lease));
		
	}
	catch (Exception e){
		e.printStackTrace(System.out);
	}
	
}
}
