package foele.jini.lease;

/**
 * This type was created in VisualAge.
 */
public class SimpleLease extends com.sun.jini.lease.AbstractLease {
	private LeaseManager LeaseManager;
	
	public static final class SimpleLeaseFactory implements LeaseFactory {
		public net.jini.core.lease.Lease createNewLease(long leaseFor,LeaseManager LeaseManager){
			//System.out.println("Factory create:"+leaseFor);
			return new SimpleLease(leaseFor,LeaseManager);
		}
	}
	private final java.rmi.dgc.VMID UOID = new java.rmi.dgc.VMID();
/**
 * SimpleLease constructor comment.
 * @param arg1 long
 */
protected SimpleLease(long arg1) {
	super(arg1);
}
/**
 * This method was created in VisualAge.
 * @param LeaseFor long
 * @param LeaseManager foele.jini.lease.LeaseManager
 * @exception net.jini.core.lease.LeaseDeniedException The exception description.
 */
public SimpleLease(long leaseFor,LeaseManager LeaseManager) {
	this(leaseFor);
	this.LeaseManager=LeaseManager;	
}
/**
 * canBatch method comment.
 */
public boolean canBatch(net.jini.core.lease.Lease arg1) {
	return false;
}
/**
 * cancel method comment.
 */
public void cancel() throws java.rmi.RemoteException, net.jini.core.lease.UnknownLeaseException {
	LeaseManager.cancel(this);
}
/**
 * createLeaseMap method comment.
 */
public net.jini.core.lease.LeaseMap createLeaseMap(long arg1) {
	return null;
}
/**
 * doRenew method comment.
 */
protected long doRenew(long arg1) throws net.jini.core.lease.LeaseDeniedException, java.rmi.RemoteException, net.jini.core.lease.UnknownLeaseException {
	System.out.println("Lease renew");
	return LeaseManager.renew(arg1,this);
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param o java.lang.Object
 */
public boolean equals(Object o) {
	if (o instanceof SimpleLease)
		return UOID.equals(((SimpleLease)o).UOID);
	else return false;
}
/**
 * This method was created in VisualAge.
 * @return int
 */
public int hashCode() {
	return UOID.hashCode();
}
}
