package foele.jini.lease.example;

/**
 * This type was created in VisualAge.
 */
public class LeasedStringHolderImpl extends java.rmi.server.UnicastRemoteObject implements LeasedStringHolder {
	private foele.jini.lease.LeasedResourceManager LeasedResourceManager;
	private StringHolder StringHolder;
/**
 * StringHolderImpl constructor comment.
 * @exception java.rmi.RemoteException The exception description.
 */
protected LeasedStringHolderImpl() throws java.rmi.RemoteException {
	super();
}
/**
 * This method was created in VisualAge.
 * @param LeasedResourceManager foele.jini.lease.LeasedResourceManager
 * @exception java.rmi.RemoteException The exception description.
 */
public LeasedStringHolderImpl(foele.jini.lease.LeasedResourceManager LeasedResourceManager) throws java.rmi.RemoteException {
	this();
	this.LeasedResourceManager=LeasedResourceManager;
	StringHolderImpl StringHolderImpl=new StringHolderImpl();
	//StringHolderImpl.unexportObject(StringHolderImpl,false);
	StringHolder=StringHolderImpl;
}
/**
 * createNewLease method comment.
 */
public net.jini.core.lease.Lease createNewLease(long leaseFor) throws net.jini.core.lease.LeaseDeniedException, java.rmi.RemoteException {
	System.out.println("create :"+ leaseFor);
	net.jini.core.lease.Lease lease=LeasedResourceManager.createNewLease(leaseFor,this);
	//System.out.println(lease);
	return lease;
}
/**
 * getString method comment.
 */
public String getString(net.jini.core.lease.Lease lease) throws java.rmi.RemoteException, net.jini.core.lease.UnknownLeaseException {
	System.out.println("getString :"+ lease);
	if (LeasedResourceManager.isValid(lease))
		return StringHolder.getString();
	else throw new net.jini.core.lease.UnknownLeaseException();
}
/**
 * This method was created in VisualAge.
 	come primo argomento il nome di registrazione, come secondo la porta, 
 	come terzo il nome di registrazione del lease resource manager come quarto la porta come quinto l'host.
 * @param args java.lang.String[]
 */
public static void main(String args[]) throws java.io.IOException{
	System.setOut(new java.io.PrintStream(new foele.io.TeeOutputStream(System.out,new java.io.PrintStream(new java.io.FileOutputStream(LeasedStringHolderImpl.class+".log")))));
	String SHIname=args[0];
	int SHIport=Integer.parseInt(args[1]);
	String LRMname=args[2];
	int LRMport=Integer.parseInt(args[3]);
	String LRMhost=args[4];
	try {
		System.setSecurityManager(new java.rmi.RMISecurityManager());
		java.rmi.registry.Registry LRMreg=java.rmi.registry.LocateRegistry.getRegistry(LRMhost,LRMport);
		foele.jini.lease.LeasedResourceManager LRM=(foele.jini.lease.LeasedResourceManager)LRMreg.lookup(LRMname);
		java.rmi.registry.Registry SHIreg=java.rmi.registry.LocateRegistry.getRegistry(SHIport);
		SHIreg.rebind(SHIname,new LeasedStringHolderImpl(LRM));
		System.out.println("Oggetti localizzati correttamente");
		
	}
	catch (Exception e){
		e.printStackTrace(System.out);
	}
}
/**
 * setString method comment.
 */
public void setString(String string, net.jini.core.lease.Lease lease) throws java.rmi.RemoteException, net.jini.core.lease.UnknownLeaseException {
	System.out.println("setString :"+ lease);
	if (LeasedResourceManager.isValid(lease))
		StringHolder.setString(string);
	else throw new net.jini.core.lease.UnknownLeaseException();
}
}
